/*
Copyright (c) 2019-2023 Digital Energy Cloud Solutions LLC. All Rights Reserved.
Authors:
Petr Krutov, <petr.krutov@digitalenergy.online>
Stanislav Solovev, <spsolovev@digitalenergy.online>

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

/*
Terraform DECORT provider - manage resources provided by DECORT (Digital Energy Cloud
Orchestration Technology) with Terraform by Hashicorp.

Source code: https://repository.basistech.ru/BASIS/terraform-provider-decort

Please see README.md to learn where to place source code so that it
builds seamlessly.

Documentation: https://repository.basistech.ru/BASIS/terraform-provider-decort/wiki
*/

package image

import (
	"context"
	"fmt"
	"strconv"
	"strings"
	"time"

	"github.com/hashicorp/terraform-plugin-sdk/v2/diag"
	"github.com/hashicorp/terraform-plugin-sdk/v2/helper/schema"
	log "github.com/sirupsen/logrus"
	"repository.basistech.ru/BASIS/decort-golang-sdk/pkg/cloudbroker/image"
	"repository.basistech.ru/BASIS/decort-golang-sdk/pkg/cloudbroker/tasks"
	"repository.basistech.ru/BASIS/terraform-provider-decort/internal/constants"
	"repository.basistech.ru/BASIS/terraform-provider-decort/internal/controller"
	"repository.basistech.ru/BASIS/terraform-provider-decort/internal/dc"
	"repository.basistech.ru/BASIS/terraform-provider-decort/internal/status"
)

func resourceImageCreate(ctx context.Context, d *schema.ResourceData, m interface{}) diag.Diagnostics {
	log.Debugf("resourceImageCreate: called for image %s", d.Get("name").(string))

	url, _ := d.GetOk("url")

	c := m.(*controller.ControllerCfg)

	syncMode := d.Get("sync_mode").(bool)
	log.Debugf("resourceImageCreate: sync_mode =  %t", d.Get("sync_mode").(bool))
	var imageId uint64

	req, err := CreateRequest(ctx, d, m, url.(string))

	if syncMode {
		if err != nil {
			return diag.FromErr(err)
		}
		imageId, err = c.CloudBroker().Image().CreateImage(ctx, req)
		log.Debugf("resourceImageCreate: imageID =  %d", imageId)
		if err != nil {
			return diag.FromErr(err)
		}
	} else {
		if err != nil {
			return diag.FromErr(err)
		}
		taskID, err := c.CloudBroker().Image().AsyncCreateImage(ctx, req)
		if err != nil {
			return diag.FromErr(err)
		}

		taskReq := tasks.GetRequest{
			AuditID: strings.Trim(taskID, `"`),
		}

		for {
			time.Sleep(time.Second * 15)
			task, err := c.CloudBroker().Tasks().Get(ctx, taskReq)
			if err != nil {
				return diag.FromErr(err)
			}

			log.Debugf("resourceAccountDelete: delete account - %s", task.Stage)

			if task.Completed {
				if task.Error != "" {
					return diag.FromErr(fmt.Errorf("cannot delete account: %v", task.Error))
				}
				id, err := task.Result.ID()
				imageId = uint64(id)
				if err != nil {
					return diag.FromErr(err)
				}
				break
			}
		}
	}

	d.SetId(strconv.FormatUint(imageId, 10))

	var w dc.Warnings

	if _, ok := d.GetOk("shared_with"); ok {
		if err := resourceImageShare(ctx, d, m); err != nil {
			w.Add(err)
		}
	}

	return append(resourceImageRead(ctx, d, m), w.Get()...)
}

func resourceImageRead(ctx context.Context, d *schema.ResourceData, m interface{}) diag.Diagnostics {
	log.Debugf("resourceImageRead: called for %s id: %s", d.Get("name").(string), d.Id())

	img, err := utilityImageCheckPresence(ctx, d, m)
	if err != nil {
		d.SetId("")
		return diag.FromErr(err)
	}

	switch img.Status {
	case status.Modeled:
		return diag.Errorf("The image is in status: %s, please, contact support for more information", img.Status)
	case status.Destroyed, status.Purged:
		d.SetId("")
		return diag.Errorf("The resource cannot be updated because it has been destroyed")
	}

	flattenImage(d, img)

	return nil
}

func resourceImageDelete(ctx context.Context, d *schema.ResourceData, m interface{}) diag.Diagnostics {
	log.Debugf("resourceImageDelete: called for %s, id: %s", d.Get("name").(string), d.Id())

	_, err := utilityImageCheckPresence(ctx, d, m)
	if err != nil {
		d.SetId("")
		return diag.FromErr(err)
	}

	c := m.(*controller.ControllerCfg)
	req := image.DeleteRequest{
		ImageID: uint64(d.Get("image_id").(int)),
	}

	_, err = c.CloudBroker().Image().Delete(ctx, req)
	if err != nil {
		return diag.FromErr(err)
	}

	d.SetId("")

	return nil
}

func resourceImageUpdate(ctx context.Context, d *schema.ResourceData, m interface{}) diag.Diagnostics {
	log.Debugf("resourceImageEdit: called for %s, id: %s", d.Get("name").(string), d.Id())

	img, err := utilityImageCheckPresence(ctx, d, m)
	if err != nil {
		d.SetId("")
		return diag.FromErr(err)
	}

	switch img.Status {
	case status.Modeled:
		return diag.Errorf("The image is in status: %s, please, contact support for more information", img.Status)
	case status.Destroyed, status.Purged:
		d.SetId("")
		return diag.Errorf("The resource cannot be updated because it has been destroyed")
	}

	if d.HasChange("enabled") {
		err := resourceImageChangeEnabled(ctx, d, m)
		if err != nil {
			return diag.FromErr(err)
		}
	}

	if d.HasChange("shared_with") {
		err := resourceImageShare(ctx, d, m)
		if err != nil {
			return diag.FromErr(err)
		}
	}

	if d.HasChange("computeci_id") {
		err := resourceImageChangeComputeci(ctx, d, m)
		if err != nil {
			return diag.FromErr(err)
		}
	}

	if d.HasChanges("name", "username", "password", "account_id", "bootable", "hot_resize", "network_interface_naming") {
		err := resourceImageEdit(ctx, d, m)
		if err != nil {
			return diag.FromErr(err)
		}
	}

	return nil
}

func resourceImageChangeEnabled(ctx context.Context, d *schema.ResourceData, m interface{}) error {
	c := m.(*controller.ControllerCfg)
	imageId := uint64(d.Get("image_id").(int))

	if d.Get("enabled").(bool) {
		req := image.EnableRequest{
			ImageID: imageId,
		}

		_, err := c.CloudBroker().Image().Enable(ctx, req)
		if err != nil {
			return err
		}
	} else {
		req := image.DisableRequest{
			ImageID: imageId,
		}

		_, err := c.CloudBroker().Image().Disable(ctx, req)
		if err != nil {
			return err
		}
	}

	return nil
}

func resourceImageShare(ctx context.Context, d *schema.ResourceData, m interface{}) error {
	log.Debugf("resourceImageShare: called for %s, id: %s", d.Get("name").(string), d.Id())
	c := m.(*controller.ControllerCfg)

	imageID, _ := strconv.ParseUint(d.Id(), 10, 64)

	sharedWith := d.Get("shared_with").([]interface{})
	if len(sharedWith) == 0 {
		req := image.RevokeAccessRequest{
			ImageID:    imageID,
			AccountIDs: []int64{-1},
		}
		_, err := c.CloudBroker().Image().RevokeAccess(ctx, req)
		if err != nil {
			return err
		}
		return nil
	}

	req := image.ShareRequest{
		ImageId: imageID,
	}
	accIds := []uint64{}
	for _, accId := range sharedWith {
		accIds = append(accIds, uint64(accId.(int)))
	}
	req.AccountIDs = accIds

	getReq := image.GetRequest{ImageID: imageID}

	for {
		image, err := c.CloudBroker().Image().Get(ctx, getReq)
		if err != nil {
			return err
		}
		if image.Status != "CREATING" {
			break
		}
		time.Sleep(time.Second * 10)
	}

	_, err := c.CloudBroker().Image().Share(ctx, req)
	if err != nil {
		return err
	}

	return nil
}

func resourceImageChangeComputeci(ctx context.Context, d *schema.ResourceData, m interface{}) error {
	c := m.(*controller.ControllerCfg)

	imageId := uint64(d.Get("image_id").(int))
	computeci := uint64(d.Get("computeci_id").(int))

	if computeci == 0 {
		req := image.ComputeCIUnsetRequest{
			ImageID: imageId,
		}

		_, err := c.CloudBroker().Image().ComputeCIUnset(ctx, req)
		if err != nil {
			return err
		}
	} else {
		req := image.ComputeCISetRequest{
			ImageID:     imageId,
			ComputeCIID: computeci,
		}

		_, err := c.CloudBroker().Image().ComputeCISet(ctx, req)
		if err != nil {
			return err
		}
	}

	return nil
}

func resourceImageEdit(ctx context.Context, d *schema.ResourceData, m interface{}) error {
	log.Debugf("resourceImageEdit: called for %s, id: %s", d.Get("name").(string), d.Id())
	c := m.(*controller.ControllerCfg)
	req := image.EditRequest{}

	req.ImageID = uint64(d.Get("image_id").(int))
	if d.HasChange("name") {
		req.Name = d.Get("name").(string)
	}
	if d.HasChange("username") {
		req.Username = d.Get("username").(string)
	}
	if d.HasChange("password") {
		req.Password = d.Get("password").(string)
	}
	if d.HasChange("account_id") {
		req.AccountID = uint64(d.Get("account_id").(int))
	}
	if d.HasChange("bootable") {
		req.Bootable = d.Get("bootable").(bool)
	}
	if d.HasChange("hot_resize") {
		req.HotResize = d.Get("hot_resize").(bool)
	}
	if d.HasChange("network_interface_naming") {
		req.NetworkInterfaceNaming = d.Get("network_interface_naming").(string)
	}
	_, err := c.CloudBroker().Image().Edit(ctx, req)
	if err != nil {
		return err
	}
	return nil
}

func ResourceImage() *schema.Resource {
	return &schema.Resource{
		SchemaVersion: 2,

		CreateContext: resourceImageCreate,
		ReadContext:   resourceImageRead,
		UpdateContext: resourceImageUpdate,
		DeleteContext: resourceImageDelete,

		Importer: &schema.ResourceImporter{
			StateContext: schema.ImportStatePassthroughContext,
		},

		Timeouts: &schema.ResourceTimeout{
			Create:  &constants.Timeout600s,
			Read:    &constants.Timeout300s,
			Update:  &constants.Timeout300s,
			Delete:  &constants.Timeout300s,
			Default: &constants.Timeout300s,
		},

		Schema: resourceImageSchemaMake(),
		StateUpgraders: []schema.StateUpgrader{
			{
				Type:    resourceImageV1().CoreConfigSchema().ImpliedType(),
				Upgrade: resourcePresentTOUpgradeV1,
				Version: 1,
			},
		},
	}
}
